/*
 * Copyright (c) 2017 Samsung Electronics Co., Ltd All Rights Reserved
 *
 * Licensed under the Apache License, Version 2.0 (the License);
 * you may not use this file except in compliance with the License.
 * You may obtain a copy of the License at
 *
 * http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an AS IS BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 * See the License for the specific language governing permissions and
 * limitations under the License.
 */

#ifndef __TIZEN_APPFW_MESSAGE_PORT_LOCAL_H__
#define __TIZEN_APPFW_MESSAGE_PORT_LOCAL_H__

#include <bundle.h>

#ifdef __cplusplus
extern "C" {
#endif

int check_remote_port(const char *remote_app_id,
			const char *remote_port,
			bool is_trusted,
			bool *exist);
int register_message_port(const char *local_port,
			bool is_trusted,
			message_port_message_cb callback,
			void *user_data);
int remove_registration_event_cb(int watcher_id);
int send_bidirectional_message(int id,
			const char *remote_app_id,
			const char *remote_port,
			bool trusted_message,
			bundle *message);
int send_message(const char *remote_appid,
		const char *remote_port,
		const char *local_port,
		bool trusted_message,
		bool local_trusted,
		bool bi_dir,
		bundle *message);
int unregister_local_port(int local_port_id, bool trusted_port);
int watch_remote_port(int *watcher_id,
	const char *remote_app_id,
	const char *remote_port,
	bool trusted_remote_port,
	message_port_registration_event_cb registered_cb,
	message_port_registration_event_cb unregistered_cb,
	void *user_data);

/**
 * @}
 */

#ifdef __cplusplus
}
#endif

#endif /*  __TIZEN_APPFW_MESSAGE_PORT_LOCAL_H__ */
